#include <stdio.h>
#include <math.h>
#define n 6000
#define n1 4096
#define n2 4032
#define r0  1.1              // 1.1*0.455 =0.5"
char head[72][80],f1[30],f3[30],b[30],c[80],d[150];
FILE   *fp,*fp1,*fp2,*fp3;
float  see,sky,gain,x1,x2,ava,sig,xx1;
float  z1,z2;
int    i0,i1,i2,ic;
double a8[8],b8[8],xx[n],yy[n],x,y,x3,x4,r,cx,cy,pi;
float  s82[n],ber[n],arr[n],drr[n];
char   mark[n],c0=34,cc;
int    ccdno,m,pg=0,idate;
float  rr[n];
float   ava4[4],sig4[4];
int    m4[4],k4[4];
char   cs82[n][33];
float  dx2[n];

main(int ac,char **av)
{
  int i,j,k,kp=0;
  if(ac<2){ printf("\n\t******* use S82 to calibrating *********** \n");
            printf("\n\tUsage: c44s82 p*.fit [!,%,g 1~4]\n");
            printf("\n\t 1~4, not draw 1/4 star\n");
            printf("\n\t mag: 15~~21.5,  s82_err<0.05m, RMS as weight\n");
            printf("\n\t ! /xw % /xw  g /jg \n\n");
            exit(0);
          }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  system("cp /vega2/rhbin/uefault.param default.param");
  system("cp /vega2/rhbin/uefault.conv default.conv");
  system("cp /vega2/rhbin/uefault.nnw default.nnw");
  cc=av[ac-1][0];
  if(cc=='!' || cc=='%' || cc=='g' || (cc<='4' && cc>='1') ){ ac--; pg=1; }
  for(i=1;i<ac;i++){
    strcpy(f1,av[i]);
    k=nindex(f1,"."); if(k<0)strcat(f1,".fit");
    sscanf(&f1[1],"%d",&k);
    idate=0;                // 2010
    if(k>5700)idate=1;  // 2011
//  if(k>6000)idate=2;
    printf("%3d: %s ******\n",i,f1);
    if(f1[0]!='p'){ printf("not a p*_? file\n"); continue; }
    fp=fopen(f1,"rb+");
    if(fp==0){ printf("not found!\n");  continue; }
    fread(head,72,80,fp);
    k=indexpos(head,"A81     ",72);
    for(j=0;j<8;j++)sscanf(&head[k+j][10],"%lf",&a8[j]);
    xytoad(a8,b8);
    k=indexpos(head,"CCD_NO: ",72); sscanf(&head[k][15],"%d",&ccdno);
    k=indexpos(head,"SEEING  ",72); sscanf(&head[k][15],"%f",&see);
    k=indexpos(head,"SKYADU  ",72); sscanf(&head[k][15],"%f",&sky);
    k=indexpos(head,"GAINCAL ",72); 
    sscanf(&head[k][10],"%f %f %lf %lf",&x1,&x2,&x3,&x4); gain=(x1+x2+x3+x4)/4.;

    strncpy(b,&head[6][53],25);
    for(j=0;j<9;j++)if(b[j]==32)break;
    if(j!=9){ printf("not coordinated!\n"); continue; }
// s82 only 4:00~~20:34 -1.3 1.3
// so pic_center ra 3.98~20.59,  -1.0~~1.0
    itohd(b,&x,&y); if(x<16.)x+=24.;
    if(x>3.98+24. || x<20.59 || y<-1.3 || y>1.3){
      printf("%lf %lf %s %s -- No S82 cali !!\n",x,y,f1,b); continue; 
    }
    sprintf(c,"s82 %s 31 c44.s82 22.0",b);
    system(c);                          
    m=0;
    fp1=fopen("c44.s82","r");
l10:
    fgets(d,90,fp1); if(feof(fp1))goto l20;
    if(d[0]=='#')goto l10;
    sscanf(&d[37],"%f%f",&s82[m],&arr[m]);  mark[m]=0;
    if(arr[m]>0.05)goto l10;
    chs(&d[5],&x3);  chs(&d[18],&x4);
    rad_xy(a8[6],a8[7],x3,x4,&x,&y,2,0);
    if(x<10. || x>n1-10.)goto l10;
    if(y<10. || y>n2-10.)goto l10;
    if(ccdno==4 && idate==0)if(x<n1/2-10. || y>n2/2-10.)goto l10;
    if(cc=='1')if(x < n1/2 && y > n2/2)goto l10; 
    if(cc=='2')if(x < n1/2 && y < n2/2)goto l10; 
    if(cc=='3')if(x > n1/2 && y > n2/2)goto l10; 
    if(cc=='4')if(x > n1/2 && y < n2/2)goto l10; 
    d[32]=0; strcpy(cs82[m],d);
    xx[m]=x; yy[m]=y;
    if(m<n)m++;
    goto l10;
l20:
    fclose(fp1); 
    if(m<2){ printf("less U standard star in this area\n"); continue; }
  
    fp2=fopen("/vega2/rhbin/uefault.sex","r");
    fp1=fopen("default.sex","w");
l30:
    fgets(c,80,fp2); if(feof(fp2))goto l40;
    if(c[0]=='G'&&c[1]=='A'&&c[2]=='I'){sprintf(&c[6],"%4.1f",gain);c[10]=9;}
    if(c[0]=='S'&&c[1]=='E'&&c[2]=='E'){sprintf(&c[12],"%5.2f",see);c[17]=9;}
    fputs(c,fp1); goto l30;
l40:
    fclose(fp1);
    sprintf(c,"sex %s",f1);
    system(c);                           // get test.cat
    fp1=fopen("test.cat","r");
l50:
    fgets(d,150,fp1);  if(feof(fp1))goto l60;
    if(d[0]=='#')goto l50;
    sscanf(&d[48],"%f %f %lf %lf",&x1,&x2,&x3,&x4);
    if(x1>25.)goto l50;
    r=r0;                      // err 1 pixel, 0.455"
    for(j=0;j<m;j++){
      x=xx[j]-x3; x*=x; 
      y=yy[j]-x4; y*=y; 
      x=sqrt(x+y);
      if(x<r){r=x; k=j; }
    } 
    if(r!=r0){
      ber[k]=s82[k]-x1;  drr[k]=1./(x2*x2+arr[k]*arr[k]);
                 // 2 end + 1.mag, 
      mark[k]=2; if(s82[k]>21.5 || s82[k]<15.)mark[k]=1;
      dx2[k]=x2;
    }
    goto l50;
l60:
    fclose(fp1);
    printf("s82: %4d    0.5%c_match: ",m,c0);
l70:
    x1=x2=0.; xx1=0.;
    for(j=k=0;j<m;j++)if(mark[j]==2){ k++; x1+=ber[j]*drr[j]; xx1+=drr[j]; }
    printf(" %4d ",k);
    ava=x1/xx1;  
    for(j=0;j<m;j++)if(mark[j]==2) x2+=(ber[j]-ava)*(ber[j]-ava);
    sig=sqrt(x2/k); 
    printf(" av: %6.3f %6.3f\n",ava,sig);
    sig*=3.;
    for(j=ic=0;j<m;j++)if(mark[j]==2){
      x2=ber[j]-ava; if(x2<0.)x2=-x2;
      rr[j]=x2;
      if(x2>sig){ mark[j]=-1; ic++; }
    }
    if(ic){ printf("\t  3_sigma_match: "); goto l70;  }

    for(ic=65;ic<69;ic++)for(j=0;j<80;j++)head[ic][j]=32;
    sig/=3.;  r=pow(10,(ava-4.)*0.4);
    sprintf(&head[59][0],"CALIS82 =%21.3f / rms:%5.3f  s82:%4d  matched:%4d  W:%7.4lf",
     ava,sig,m,k,r);    for(j=77;j<80;j++)head[59][j]=32;
    printf("Weight: %7.4lf\n",r);
    if(k<9){ for(j=0;j<80;j++)head[59][j]=32;
              printf("******* less matched (<10), not write down to file\n"); }
    fseek(fp,0,0); fwrite(head,72,80,fp); fclose(fp);
    if( cc>='1' && cc<='4' )cc='!';

    if(k<9)continue;
    if(pg){
      i0=0; i1=1;
      if(cc=='!' || cc=='%')pgbegin_(&i0,"/xw",&i1,&i1,3);
      if(cc=='g')pgbegin_(&i0,"/jg",&i1,&i1,3);
      if(cc=='%'){
        x1=610., x2=600.;              pgpap_(&x1,&x2);
        x1=z1=0.; x2=4096.; z2=4032.;  pgenv_(&x1,&x2,&z1,&z2,&i0,&i0);
        pglabel_("s82-ber-cali_mag, red circle under AV","16.~~20.5m",f1,37,10,strlen(f1));
        for(j=0;j<m;j++)if(mark[j] && s82[j]>16. && s82[j]<20.5){
          z1=xx[j]; z2=yy[j]; pgpoint_(&i1,&z1,&z2,&i1);
          x1=(ber[j]-ava)*9.;
          ic=2; if(x1<0.){ x1=-x1; ic=1; }   pgsci_(&ic);
          i2=x1+0.5; i2+=21; 
          if(i2<27){ z1=xx[j]; z2=yy[j]; pgpoint_(&i1,&z1,&z2,&i2); }
        } pgend_();        continue;
      }
      x1=600., x2=600.;        pgpap_(&x1,&x2);
      x1=14.; x2=23.; z1=10.; z2=19.;
      pgsci_(&i1); pgenv_(&x1,&x2,&z1,&z2,&i0,&i0);
      pglabel_("S82_med","Bertin_auto",f1,7,11,strlen(f1));
      sprintf(c,"cali:%9.3f  rms:%9.3f  %d/%d",ava,sig,k,m);
      x1=14.5; z1=18.0; pgtext_(&x1,&z1,c,strlen(c));
      sprintf(c,"skyadu:  %9.2f",sky);
      x1=14.5; z1=17.5; pgtext_(&x1,&z1,c,strlen(c));
      sprintf(c,"seeing:%9.2f",see);
      x1=14.5; z1=17.0; pgtext_(&x1,&z1,c,strlen(c));

    strcpy(f3,f1); f3[strlen(f3)-3]=0; strcat(f3,"cali");
    f3[0]='s'; fp3=fopen(f3,"w");
    fprintf(fp3,"#MARK: 2 green; 1 outMag; -1 3s_del   X     Y   S82(med) err Ber(best) err Mark\n#");
    for(j=0;j<76;j++)fprintf(fp3,"-"); fprintf(fp3,"\n");

      for(j=0;j<m;j++)if(mark[j]){
        ic=mark[j]*2-1; if(ic<0)ic=-ic; pgsci_(&ic);
        x1=s82[j]; x2=s82[j]-ber[j];
        pgpoint_(&i1,&x1,&x2,&i1);
        fprintf(fp3,"%s%8.2lf%8.2lf%7.3f%6.3f%7.3f%6.3f%3d\n",
               cs82[j],xx[j],yy[j],s82[j],arr[j],x2,dx2[j],mark[j]);
      }
   fclose(fp3);

      pgend_();
      if(cc=='g'){
        strcpy(b,f1); b[0]='s';
        k=strlen(b)-3; b[k++]='g'; b[k++]='i'; b[k]='f';
        if(kp==0)sprintf(c,"mv pgplot.gif %s",b);
        else     sprintf(c,"mv pgplot%d.gif %s",kp%10,b); 
        system(c); kp++;
        printf("%s\n",c);
      } 
    }
    if(ccdno==4 && idate==0)continue;
    for(j=0;j<4;j++){
      get4cali(m,j+1,&ava4[j],&sig4[j],&m4[j],&k4[j]);
      if(k4[j]==0){ ava4[j]=ava; sig4[j]=sig; }
      r=pow(10,(ava4[j]-4.)*0.4);
      printf("Gate %d:%4d/%d   av:%8.3f%7.3f  Weight: %7.4f\n",
              j+1,k4[j],m4[j],ava4[j],sig4[j],r);
      sprintf(&head[j+65][0],"CALIS82%d=%21.3f / rms:%5.3f  s82:%4d  matched:%4d  W:%7.4lf",
      j+1,ava4[j],sig4[j],m4[j],k4[j],r);    head[j+65][77]=32;
    }
    fp=fopen(f1,"rb+"); fseek(fp,0,0); fwrite(head,72,80,fp); fclose(fp);
  }
}

get4cali(m,gate,ava4,sig4,m4,k4)
int m,gate,*m4,*k4; float *ava4,*sig4;
{
  int j,k,ic,mm=0;
  float ava,sig, x1,x2,xx1;
  *k4=0;
  for(j=0;j<m;j++)if(mark[j]>0){
    mark[j]=2; if(s82[j]>21.5 || s82[j]<15.)mark[j]=1;
    if(gate==1)if(xx[j]>n1/2 || yy[j]<n2/2)mark[j]=1;
    if(gate==2)if(xx[j]>n1/2 || yy[j]>n2/2)mark[j]=1;
    if(gate==3)if(xx[j]<n1/2 || yy[j]<n2/2)mark[j]=1;
    if(gate==4)if(xx[j]<n1/2 || yy[j]>n2/2)mark[j]=1;
    if(mark[j]==2)mm++;
  } *m4=mm; if(mm<8)return;
l70:
  x1=x2=xx1=0.;
  for(j=k=0;j<m;j++)if(mark[j]==2){ k++; x1+=ber[j]*drr[j]; xx1+=drr[j]; }
  ava=x1/xx1;
  for(j=0;j<m;j++)if(mark[j]==2) x2+=(ber[j]-ava)*(ber[j]-ava);
  sig=sqrt(x2/k);
  for(j=ic=0;j<m;j++)if(mark[j]==2){
    x2=ber[j]-ava; if(x2<0.)x2=-x2;
    if(x2>3.*sig){ mark[j]=1; ic++; }
  } if(ic)goto l70;
  *ava4=ava; *sig4=sig;
  *k4=k;
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[128];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
/*                         // same discribe formula as following 3 lines
  double sd,cd,td,co;      // china bai_ke_quan_shu (astronmy) p.552
  sd=sin(dc);  cd=cos(dc);  td=tan(der);
  co=cos(rar-ac);  tmp=sd*td+cd*co;
  xi=sin(rar-ac)/tmp;
  xn=(cd*td-sd*co)/tmp;
*/
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}
itohd(a,rc,dc)
char *a; double *rc,*dc;
{
  int i,j,k;
  int i1,i2,j1,j2;
  double x3,y3;
  char b[70];
  strcpy(b,a);
  for(i=0;i<24;i++)if(b[i]==':')b[i]=32;
  k=1; if(b[11]=='-'){ b[11]=32; k=-1; }
  sscanf(b,"%d %d %lf %d %d %lf",&i1,&i2,&x3,&j1,&j2,&y3);
//  printf("%2d %2d %5.2lf %2d %2d %4.1lf\n",i1,i2,x3,j1,j2,y3);
  x3=i1+i2/60.+x3/3600.;
  y3=j1+j2/60.+y3/3600.; if(k==-1)y3=-y3;
  *rc=x3;
  *dc=y3;
}

